
template <class DT>
struct LNode  //结点
{
	DT data;     //数据域，存储数据元素值
	LNode *next;//指针域，指向下一个结点
};


//【算法3.6】
template <class DT>
void InitStack(LNode<DT> *&S)//创建空链栈
{
	//L=new LNode<DT>;     //创建头结点
	//if(!L) exit(1);  //创建失败，结束运行
	S=NULL;
}

//【算法3.7】
template <class DT>
void DestroyStack(LNode<DT> *(&S))//释放链栈
{
	LNode<DT> *p;
	while(S)//从头结点开始，依次释放结点
	{
		p=S;
		S=S->next;
	    delete p;
	}
	//L=NULL;//头结点指向空
}

//【算法3.8】
template<class DT>
bool Push(LNode<DT> *&S,DT e)
{
    LNode<DT> *p;
    p=new LNode<DT>;
    if(!p) return false;  //创建失败，结束运行
    p->data=e;       // 新结点赋值
    p->next=S;  //结点S链接到p结点之后
    S=p;
	return true;    // 插入成功，返回true
}

//【算法3.9】
template<class DT>
bool Pop(LNode<DT> *&S,DT &e)
{
    LNode<DT> *p;
    if(S==NULL)  return false;
    p=S;
    e=p->data;
    S=S->next;
    delete p;
	return true;    // 删除成功，返回true
}


//【算法3.10】
template<class DT>
bool GetTop(LNode<DT> *S,DT &e)
{
	LNode<DT> *p;
    if(S==NULL)  return false;
    p=S;
    e=p->data;
	return true;    // 删除成功，返回true
}

//测栈空
template<class DT>
bool StackEmpty(LNode<DT> *S)
{
	if(S==NULL)
		return true;
	else
		return false;
}

//显示栈内容
template<class DT>
void DispStack(LNode<DT> *S)
{
    LNode<DT> *p;
    p=S;
	while(p)
	{
		cout<<p->data<<"\t";
		p=p->next;
	}
	cout<<endl;
}

